GenerateCCs <- function(data) 
{    
#   data = GeneImport()
#    print(dim(data))
#    if (data==FALSE) 
#    {
#        message <- tktoplevel()
#        label.widget <- tklabel(message, text="Must Import Data First")
#        button.widget <- tkbutton(message, text="OK", command=function() tkdestroy(message))
#        tkpack(label.widget, button.widget)
#        return()
#    }
#    library(tkWidgets) 
    
    library(cluster)
    geneid = data[[2]]
    expts = data[[3]]
    data = data[[1]]
    datadim = dim(data)
    n=datadim[1]
    
    methods=c("SingleLink", "CompleteLink", "AverageLink", "PAM", "KMEANS")
    selection=pickItems(methods)
    nm = length(selection)
    params=GetCCParameter()
    nk=as.double(params[[1]])
    iter=as.double(params[[2]])
    
    print(selection)
    print(params)
    
#   print(n)
#   print(len)
    pearsonmat = cor(t(data), use="pairwise")
#   print(dim(pearsonmat))
    pearsonmat = as.dist(1-abs(pearsonmat))

    
    #AVLINK
    avgo=FALSE
    for (i in 1:nm)
    {
            if (selection[i]=="AverageLink") avgo=TRUE
    }
    if (avgo==TRUE)
    {
        avlink = hclust(pearsonmat, method="average")
        avlink = cutree(avlink, k=nk)
    }
    #SINGLINK
    singgo=FALSE
    for (i in 1:nm)
    {
            if (selection[i]=="SingleLink") singgo=TRUE
    }
    if (singgo==TRUE)
    {
        singlink = hclust(pearsonmat, method="single")
        singlink = cutree(singlink, k=nk)
    }
    #COMPLINK
    compgo=FALSE
    for (i in 1:nm)
    {
            if (selection[i]=="CompleteLink") compgo=TRUE
    }
    if (compgo==TRUE)
    {
        complink = hclust(pearsonmat, method="complete")
        complink = cutree(complink, k=nk)
    }
    #PAM
    pamgo=FALSE
    for (i in 1:nm)
    {
            if (selection[i]=="PAM") pamgo=TRUE
    }
    if (pamgo==TRUE)
    {
        pamres = pam(pearsonmat, k=nk)
        pamres = pamres$cluster
    }
    #KMEANS
    kmgo=FALSE
    for (i in 1:nm)
    {
            if (selection[i]=="KMeans") kmgo=TRUE
    }
    if (kmgo==TRUE)
    {    
        #Get number of clusters
        
        kmeansres = kmeans(data, nk, 100)
        kmeansres = kmeansres$cluster
    }
    
#    print(avlink)
#    print(pam)
#    print(kmeans)

    clusters = c()
    if (avgo==TRUE) clusters = c(clusters, avlink)
    if (singgo==TRUE) clusters = c(clusters, singlink)
    if (compgo==TRUE) clusters = c(clusters, complink)
    if (pamgo==TRUE) clusters = c(clusters, pamres)
    if (kmgo==TRUE) clusters = c(clusters, kmeansres)
    clusters = matrix(clusters, n, nm)
    
    amat = Agreemat(t(clusters))
    print(dim(amat))
    cc = Consensus(amat,nk,1,iter)
    
#   WRITE OUTPUT TO TEXTFILE
    cc = matrix(c(geneid, cc), n, 2)
#    print(cc)
    write(t(cc), file="ConsensusClusters.out", ncol=2)
    GenerateCCs = cc

}
